<script type='text/javascript'>
window.init_pinger_mraid = function() {
    var MRAID_STATES = {
        LOADING:            "loading",
        DEFAULT:            "default",
        EXPANDED:           "expanded",
        HIDDEN:             "hidden",
        RESIZED:            'resized'
    };
    
    var MRAID_EVENTS = {
        ERROR:              "error",
        READY:              "ready",
        STATE_CHANGE:       "stateChange",        
        VIEWABLE_CHANGE:    "viewableChange",
        SIZE_CHANGE:        'sizeChange'
    };
    
    var MRAID_EXPAND_PROPERTIES = {
        width: 320,
        height: 480,
        useCustomClose: false,
        isModal: true,        
    };

    var MRAID_ORIENTATION_PROPERTIES = {
        allowOrientationChange: true,
        forceOrientation: 'none',
    };

    var MRAID_RESIZE_PROPERTIES = {
        width: -1,
        height: -1,
        offsetX: 0,
        offsetY: 0,
        customClosePosition: 'top-right',
        allowOffscreen: true,
    };

    var MRAID_CURRENT_POSITION = {
        x: 0,
        y: 0,
        width: 0,
        height: 0,
    };

    var MRAID_MAX_SIZE = {
        width: 0,
        height: 0,
    };

    var MRAID_SCREEN_SIZE = {
        width: 0,
        height: 0,
    };

    var MRAID_DEFAULT_POSITION = {
        x: 0,
        y: 0,
        width: 0,
        height: 0,
    };

    var MRAID_SUPPORT = {
        sms: false,
        tel: false,
        calendar: false,
        storePicture: true,
        inlineVideo: true,
    };
    
    var _pingerSDKCallBack = "pingerSDKCallBack://";
    var MRAID_ACTIONS = {
        EXPAND:              "expand",
        CLOSE:               "close",
        OPEN:                "open",
        RESIZE:              'resize',
        SET_ORIENTATION_P:   'set_orientation_properties',
        STORE_PICTURE:       'store_picture',
        CREATE_CAL_EVENT:    'create_calendar_event',
        PLAY_VIDEO:          'play_video'
    }

    var LOG_LEVEL = {
        INFO:              "INFO",
        SEVERE:            "SEVERE",
        WARNING:           "WARNING",
    }
    
    var _mraidAdState = MRAID_STATES.LOADING;
    var _mraidAdIsViewable = "NO";
    var _placementType = "inline";
    var viewId = "0";
    
    var b = window.mraid = {};
    var listeners = [];

    function internalAddListener(event, listener) {
        if (typeof listeners[event] == "undefined") {
            listeners[event] = [];
        }
        listeners[event].push(listener);
    }
    
    function internalRemoveListener(event, listener) {
        if (listeners[event] instanceof Array) {
            var allListeners = listeners[event];
            for (var i = 0, len = allListeners.length; i < len; i++) {
                if (listener === allListeners[i]) {
                    allListeners.splice(i,1);
                }
            }
        }
    }
    
    function internalFireEvent() {
        var event = arguments[0];
        if (listeners[event] instanceof Array) {
            var allListeners = listeners[event];
            for (var i = 0, len = allListeners.length; i < len; i++) {
                var listener = allListeners[i];
                
                if (event === MRAID_EVENTS.STATE_CHANGE) {
                    listener.call(this, arguments[1]);
                } else if (event === MRAID_EVENTS.READY) {
                    listener.call(this);
                } else if (event === MRAID_EVENTS.ERROR) {
                    listener.call(this, arguments[1], arguments[2]);
                } else if (event === MRAID_EVENTS.VIEWABLE_CHANGE) {
                    listener.call(this, arguments[1]);
                }
            }
        }
    }

    mraid.setViewId= function (id) {
        viewId = id;
    }

    mraid.getState = function () {
        return _mraidAdState;
    }

    mraid.sendMraidProperties = function(){
        Android.setMraidProperties(MRAID_ORIENTATION_PROPERTIES.forceOrientation, MRAID_ORIENTATION_PROPERTIES.allowOrientationChange, MRAID_EXPAND_PROPERTIES.useCustomClose, 
                MRAID_EXPAND_PROPERTIES.width, MRAID_EXPAND_PROPERTIES.height, MRAID_EXPAND_PROPERTIES.isModal);
    }

    mraid.getExpandProperties = function () {
        return MRAID_EXPAND_PROPERTIES;
    }
    
    mraid.setExpandProperties = function (a) {
    	if (a.useCustomClose != undefined) {
    	    MRAID_EXPAND_PROPERTIES.useCustomClose = a.useCustomClose;
            if (_mraidAdState == MRAID_STATES.EXPANDED) {
                mraid.sendMraidProperties();
            }
    	}
    
    	if (a.width != undefined) {
    	    MRAID_EXPAND_PROPERTIES.width = a.width;
    	}
    
    	if (a.height != undefined) {
    	    MRAID_EXPAND_PROPERTIES.height = a.height;
    	}
    
    	if (a.isModal != undefined) {
    	    MRAID_EXPAND_PROPERTIES.isModal = a.isModal;
    	}
    }
    
    mraid.getUseCustomClose = function () {
        return MRAID_EXPAND_PROPERTIES.useCustomClose;
    }
    
    mraid.useCustomClose = function (a) {
        MRAID_EXPAND_PROPERTIES.useCustomClose = a;
    }
    
    mraid.contentWidth = function () {
        return MRAID_EXPAND_PROPERTIES.width;
    }
    
    mraid.contentHeight = function () {     
        return MRAID_EXPAND_PROPERTIES.height;
    }
    
    mraid.isViewable = function () {
        return _mraidAdIsViewable;
    }
    
    mraid.getVersion = function() {
        return "2.0";
    }
    
    mraid.getCurrentPosition = function () {
        return MRAID_CURRENT_POSITION;
    }

    mraid.setCurrentPosition = function (x, y, width, height) {
        MRAID_CURRENT_POSITION.x = x;
        MRAID_CURRENT_POSITION.y = y;
        MRAID_CURRENT_POSITION.width = width;
        MRAID_CURRENT_POSITION.height = height;
    }

    mraid.getMaxSize = function () {
        return MRAID_MAX_SIZE;
    }

    mraid.setMaxSize = function (width, height) {
        MRAID_MAX_SIZE.width = width;
        MRAID_MAX_SIZE.height = height;
    }

    mraid.getScreenSize = function () {
        return MRAID_SCREEN_SIZE;
    }

    mraid.setScreenSize = function (width, height) {
        MRAID_SCREEN_SIZE.width = width;
        MRAID_SCREEN_SIZE.height = height;
    }

    mraid.getDefaultPosition = function () {
        return MRAID_DEFAULT_POSITION;
    }

    mraid.setDefaultPosition = function (x, y, width, height) {
        MRAID_DEFAULT_POSITION.x = x;
        MRAID_DEFAULT_POSITION.y = y;
        MRAID_DEFAULT_POSITION.width = width;
        MRAID_DEFAULT_POSITION.height = height;
    }

    mraid.setPlacementType = function (placementType) {
        _placementType = placementType;
    }

    mraid.getPlacementType = function() {
        return _placementType;
    }
    
    mraid.expand = function(url) {
        if (url == undefined) {
            Android.treatEvent(MRAID_ACTIONS.EXPAND, null, viewId, 
                MRAID_EXPAND_PROPERTIES.width, MRAID_EXPAND_PROPERTIES.height, MRAID_EXPAND_PROPERTIES.useCustomClose, false, -1, -1, -1, -1);
        } else {
            Android.treatEvent(MRAID_ACTIONS.EXPAND, encodeURIComponent(url), viewId, 
                MRAID_EXPAND_PROPERTIES.width, MRAID_EXPAND_PROPERTIES.height, MRAID_EXPAND_PROPERTIES.useCustomClose, false, -1, -1, -1, -1);
        }
    }
    
    mraid.open = function(url) {
        Android.treatEvent(MRAID_ACTIONS.OPEN, encodeURIComponent(url), null, -1, -1, false, false, -1, -1, -1, -1);
    }
    
    mraid.close = function() {
        Android.treatEvent(MRAID_ACTIONS.CLOSE, null, null, -1, -1, false, false, -1, -1, -1, -1);
    }

    mraid.getOrientationProperties = function () {
        return MRAID_ORIENTATION_PROPERTIES;
    }

    mraid.setOrientationProperties = function (properties) { 
        Android.log(LOG_LEVEL.INFO, "setOrientationProperties()");
        if (typeof properties === undefined) {
            return;
        }
        MRAID_ORIENTATION_PROPERTIES = properties;
    
        if (properties.forceOrientation !== 'portrait' && properties.forceOrientation !== 'landscape' && properties.forceOrientation !== 'none' ){
            internalFireEvent(MRAID_EVENTS.ERROR, 'Invalid orientationProperties forceOrientation property', 'mraid.setOrientationProperties()');
            MRAID_ORIENTATION_PROPERTIES.forceOrientation = 'none';
        }
    
        if (typeof properties.allowOrientationChange !== 'boolean'){
            internalFireEvent(MRAID_EVENTS.ERROR, 'Invalid orientationProperties allowOrientationChange property', 'mraid.setOrientationProperties()');
            MRAID_ORIENTATION_PROPERTIES.allowOrientationChange=true;
        }
    
        if (_mraidAdState == MRAID_STATES.EXPANDED) {
            mraid.sendMraidProperties();
        }
    }

    mraid.getResizeProperties = function () {
        return MRAID_RESIZE_PROPERTIES;
    }

    mraid.setResizeProperties = function (props) {
        MRAID_RESIZE_PROPERTIES = props;
        Android.log(LOG_LEVEL.INFO, "setResizeProperties() = " + MRAID_RESIZE_PROPERTIES.width + " " + MRAID_RESIZE_PROPERTIES.height + " " + MRAID_RESIZE_PROPERTIES.offsetX + " " + MRAID_RESIZE_PROPERTIES.offsetY);
        if (props.customClosePosition != 'top-right' && props.customClosePosition != 'top-left' && props.customClosePosition != 'center' && props.customClosePosition != 'bottom-left' && props.customClosePosition != 'bottom-right' && props.customClosePosition != 'top-center' && props.customClosePosition != 'bottom-center'){
            MRAID_RESIZE_PROPERTIES.customClosePosition = 'top-right';
        }
    }

    mraid.resize = function() {
        if (MRAID_RESIZE_PROPERTIES.height < 0 || MRAID_RESIZE_PROPERTIES.width < 0){
            internalFireEvent(MRAID_EVENTS.ERROR, 'mraid.resize() called before mraid.setResizeProperties()', 'mraid.resize()');
            return;
        }
        var customClosePosition = 0;
        if (MRAID_RESIZE_PROPERTIES.customClosePosition == "top-left") {
            customClosePosition = 1;
        }
        if (MRAID_RESIZE_PROPERTIES.customClosePosition == "center") {
            customClosePosition = 2;
        }
        if (MRAID_RESIZE_PROPERTIES.customClosePosition == "bottom-left") {
            customClosePosition = 3;
        }
        if (MRAID_RESIZE_PROPERTIES.customClosePosition == "bottom-right") {
            customClosePosition = 4;
        }
        if (MRAID_RESIZE_PROPERTIES.customClosePosition == "top-center") {
            customClosePosition = 5;
        }
        if (MRAID_RESIZE_PROPERTIES.customClosePosition == "bottom-center") {
            customClosePosition = 6;
        }
        Android.log(LOG_LEVEL.INFO, "resize() = " + MRAID_RESIZE_PROPERTIES.width + " " + MRAID_RESIZE_PROPERTIES.height + " " + MRAID_RESIZE_PROPERTIES.offsetX + " " + MRAID_RESIZE_PROPERTIES.offsetY);
        Android.treatEvent(MRAID_ACTIONS.RESIZE, null, viewId, MRAID_RESIZE_PROPERTIES.width, MRAID_RESIZE_PROPERTIES.height, 
            customClosePosition, MRAID_RESIZE_PROPERTIES.allowOffscreen, 
            MRAID_RESIZE_PROPERTIES.offsetX, MRAID_RESIZE_PROPERTIES.offsetY, MRAID_CURRENT_POSITION.x, MRAID_CURRENT_POSITION.y);
    }

    mraid.setSupportsSMS = function(val){
        MRAID_SUPPORT.sms = val;
    }

    mraid.setSupportsTel = function(val){
        MRAID_SUPPORT.tel = val;
    }

    mraid.setSupportsCalendar = function(val){
        MRAID_SUPPORT.calendar = val;
    }

    mraid.setSupportsStorePicture = function(val){
        MRAID_SUPPORT.storePicture = val;
    }

    mraid.setSupportsInlineVideo = function(val){
        MRAID_SUPPORT.inlineVideo = val;
    }

    mraid.supports=function(feature){
        if (mraid.getState() == 'loading'){
            internalFireEvent(MRAID_EVENTS.ERROR, 'Method mraid.supports() called during loading state.', 'mraid.supports()');
            return;
        }
        switch(feature){
        case 'sms':
            return MRAID_SUPPORT.sms;
        case 'tel':
            return MRAID_SUPPORT.tel;
        case 'calendar':
            return MRAID_SUPPORT.calendar;
        case 'storePicture':
            return MRAID_SUPPORT.storePicture;
        case 'inlineVideo':
            return MRAID_SUPPORT.inlineVideo;
        }
        internalFireEvent(MRAID_EVENTS.ERROR, 'Unknown feature to check for support: ' + feature, 'mraid.supports()');
        return false;
    }

    mraid.storePicture = function(url) {
        Android.treatEvent(MRAID_ACTIONS.STORE_PICTURE, encodeURIComponent(url), null, -1, -1, false, false, -1, -1, -1, -1);
    }

    mraid.createCalendarEvent = function(event) {
        Android.treatEvent(MRAID_ACTIONS.CREATE_CAL_EVENT, encodeURIComponent(JSON.stringify(event)), null, -1, -1, false, false, -1, -1, -1, -1);
    }

    mraid.playVideo = function(url) {
        Android.treatEvent(MRAID_ACTIONS.PLAY_VIDEO, encodeURIComponent(url), null, -1, -1, false, false, -1, -1, -1, -1);
    }

    mraid.addEventListener = function (event, listener) {
        internalAddListener(event, listener);
    }

    mraid.removeEventListener = function (event, listener) {
        internalRemoveListener(event, listener);
    }
    
    mraid.treatSDKCallbacks = function () {
        var callback = arguments[0];
        if (callback != undefined) {
            if (callback === MRAID_EVENTS.STATE_CHANGE) {
                var newState = arguments[1];
                if (newState != undefined) {
                    _mraidAdState = newState;
                    internalFireEvent(MRAID_EVENTS.STATE_CHANGE, newState);
                }
            } else if (callback === MRAID_EVENTS.READY) {
                internalFireEvent(MRAID_EVENTS.READY);
            } else if (callback === MRAID_EVENTS.ERROR) {
                var message = arguments[1];
                var action = arguments[2];
                if (message != undefined && action != undefined) {
                    internalFireEvent(MRAID_EVENTS.ERROR, message, action);
                }
            } else if (callback === MRAID_EVENTS.VIEWABLE_CHANGE) {
                var value = arguments[1];
                if (value != undefined) {
                    _mraidAdIsViewable = value;
                    internalFireEvent(MRAID_EVENTS.VIEWABLE_CHANGE, value);
                }
            } else if (callback === MRAID_EVENTS.SIZE_CHANGE) {
                internalFireEvent(MRAID_EVENTS.SIZE_CHANGE);
            }
        }
    }
};

window.mraid || window.init_pinger_mraid();
window.pingerMraid = window.mraid;
</script>
